package
{
	import starling.display.Image;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;

	
	public class MainMenu extends Sprite
	{
		private var menu_logo:Image;
		public function MainMenu()
		{
			super();	
			menu_logo = new Image(Assets.getTexture("logoImg"));
			this.addChild(menu_logo);				
			menu_logo.scaleX = menu_logo.scaleY = GS.scaleIndex;
			
			menu_logo.visible = true;
			menu_logo.alpha =0.999;
		}

		
//-----------------------------------------------------------------------------------------------			
		private function onEnterFrame():void
		{
			
		}		
//--------------------------------------------------------------------------------------------		
		
		private var touch:Touch;
		private var touchX:Number;
		private var touchY:Number;
		//+++++++++++++++++++++++
		private function onTouch(e:TouchEvent):void
		{
			try
			{
				touch = e.getTouch(stage);
				touchX = touch.globalX;
				touchY = touch.globalY;			
			}   catch (error:Error){}
			
			if (touch)
			{
				if (touch.phase == TouchPhase.BEGAN)
				{
					Game.gameState =100;
					//trace ("click");
				}
			}
		}		
//-------------скрываем .--------------------------------------------------------
		public function hide():void
		{
			if (stage.hasEventListener(starling.events.TouchEvent.TOUCH)) stage.removeEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			if (this.hasEventListener(starling.events.Event.ENTER_FRAME)) this.removeEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);
			this.visible =false;
		}		
//-------------открываем .--------------------------------------------------------
		public function show():void
		{
			Game.gameState =0;
			stage.addEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			this.addEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);	
			this.visible =true;			
		}		
	}
}