package
{

	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.SoundChannel;
	import flash.ui.Keyboard;
	import flash.utils.Timer;
	
	import gameClasses.Bullet;
	import gameClasses.Effect;
	import gameClasses.Man;
	import gameClasses.Map;
	import gameClasses.Mob;
	import gameClasses.Sparks;
	
	import starling.animation.Juggler;
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.KeyboardEvent;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.text.TextField;
	import starling.textures.RenderTexture;

	
	public class RunGame extends Sprite
	{
		public static var canvasSprite:Sprite = new Sprite();
		public static var effectsSprite:Sprite = new Sprite();
		public static var buttonsSprite:Sprite = new Sprite();
		
		private var bg:Image;
		private var headImg:Image;
		public  var energyQuad:Quad; //индикатор энергии
		
		public static var map:Map ;
		public static var man:Man ;
		
		public static var canvas:RenderTexture;
		protected var canvasImg:Image;

		public static var tintQuad:Quad;
		
		public static var 	viewPoint		:Point 		= new Point(); 
		public static var 	viewRect		:Rectangle	= new Rectangle(); 

		public static var 	shake		 	:int 		=0;
		
		public static var 		keyPressedRight	:Boolean;
		public static  var 		keyPressedLeft 	:Boolean;
		public static  var 		keyPressedUp   	:Boolean;
		public static  var 		keyPressedDown 	:Boolean;
		public static  var 		mousePressed   	:Boolean;
		
		private var			themeSC:SoundChannel;
		
		public static var   hold:Boolean = true;
		public static var	mobRespCounter:int =0;
		public static var	maxMobs:int =10;
		
		public static var 	testQuad:Quad = new Quad(32,8,0x00ff0064);
		
		private var counterLabel:TextField;
		
		
		public function RunGame()
		{
			super();
			this.scaleX = this.scaleY = GS.scaleIndex;
			this.touchable =false;
			
			map =  new Map();
			
			Mob.getOne(1);
			Mob.getOne(1);
			Mob.getOne(1);
			Mob.getOne(1);
			Mob.getOne(1);

			canvas = new RenderTexture(GS.gameWidth,GS.gameHeight,false);
			canvasImg = new Image(canvas);
			canvasImg.alpha = 0.999;
			this.addChild(canvasImg);
			
			headImg = new Image(Assets.getAtlas().getTexture("head"));
			this.addChild(headImg);
			
			energyQuad = new Quad(182,5,0x00ff00);
			energyQuad.x =52;
			energyQuad.y =30;
			this.addChild(energyQuad);

			man = new Man();
			this.addChild(man);
	
			
			
			
			
			this.addChild(canvasSprite);
			this.addChild(effectsSprite);
			this.addChild(buttonsSprite);

			
			this.addEventListener(starling.events.KeyboardEvent.KEY_DOWN,KeyDownListener_func);
			this.addEventListener(starling.events.KeyboardEvent.KEY_UP,  KeyUpListener_func);

			
			
			tintQuad = new Quad(GS.gameWidth,GS.gameHeight,0xff0000,false);	
			tintQuad.alpha =0.01;
			RunGame.canvasSprite.addChild(tintQuad);
			
			new Sparks();
			mobRespCounter =0;
			counterLabel = new TextField(300,50,"Girls:"+ GS.girlsCounter , "Verdana",16, 0xFF00FF,true);
			
			this.addChild(counterLabel);
			counterLabel.x = 256;
			counterLabel.y = 8;
			
			var infoLabel:TextField = new TextField(500,15,"HINT: Use Arrows to move, and [space] to hit and fuck. Sex will restore health." , "Verdana",9, 0xcccccc,true);
			infoLabel.x = 10;
			infoLabel.y = 300;
			this.addChild(infoLabel);
		}
		
//-------------------------------------------------------------------		
		private function doRestart():void
		{
			Man.mode = 0;
			man.changeAnimState(0);
			Man.mojo = 182;
			Man.fuckingTaget = null;
			Mob.clear();
			mobRespCounter =0;
			GS.girlsCounter =0;
			themeSC = Assets.theme_sound.play(0,1000);
			
		}
		
//-------------------------------------------------------------------		
		
		private function KeyUpListener_func(e:starling.events.KeyboardEvent):void
		{
			if ( Game.gameState ==100)
			{
				switch (e.keyCode) 
				{
					case Keyboard.SPACE:
						Man.shooting = false;
						break;
					
					case Keyboard.UP:
					case Keyboard.W:
						keyPressedUp=false;
						man.dy=0;
						if (Man.curState <10)man.changeAnimState(0)	else man.changeAnimState(10);
						break;
					
					case Keyboard.DOWN:
					case Keyboard.S:
						keyPressedDown=false;
						man.dy=0;
						if (Man.curState <10)man.changeAnimState(0)	else man.changeAnimState(10);
						break;
					
					case Keyboard.LEFT:
					case Keyboard.A:	
						keyPressedLeft=false;
						man.dx=0;
						man.changeAnimState(10);
						break;
					
					case Keyboard.RIGHT:
					case Keyboard.D:	
						keyPressedRight=false;
						man.dx=0;
						man.changeAnimState(0);
						break;	
					case Keyboard.SHIFT:
						break;
					
				}			
			}		
		}
		
		private function KeyDownListener_func(e:starling.events.KeyboardEvent):void
		{
			if (Game.gameState == 100) 
			{	
				switch (e.keyCode) 
				{
					case Keyboard.UP:
					case Keyboard.W:
						keyPressedUp=true;
						keyPressedDown=false;
						if (Man.curState <10)man.changeAnimState(1)	else man.changeAnimState(11);		
						break;
					case Keyboard.DOWN:
					case Keyboard.S:
						keyPressedUp=false;
						keyPressedDown=true;
						if (Man.curState <10)man.changeAnimState(1)	else man.changeAnimState(11);		
						break;
					
					
					case Keyboard.LEFT:
					case Keyboard.A:
						keyPressedRight=false;
						keyPressedLeft=true;
						man.changeAnimState(11);
						break;
					
					case Keyboard.RIGHT:
					case Keyboard.D:	
						keyPressedRight=true;
						keyPressedLeft=false;
						man.changeAnimState(1);
						break;
					
					
					case Keyboard.SPACE:
						
						if (!Man.shooting)
						{							
							Man.shooting = true;
							Man.shootingCounter =0;
							if (Man.curState <10)man.changeAnimState(2)
							else man.changeAnimState(12);
							man.dx=0;
							man.dy=0;
							keyPressedRight=false;
							keyPressedLeft=false;
							keyPressedUp=false;
							keyPressedDown=false;
							man.hit();
						}						
						break;
				}
			}			
		}
		
//-----------------------------------------------------------------------------------------------			
		final private function onEnterFrame():void
		{				
			if (Man.mojo <=0)
			{
				Game.gameState =200;
			}
			
			if (Mob.activeMobs.length < maxMobs)
			{
				Mob.getOne(1);
			}
			
			
			if (tintQuad.alpha > 0.01)tintQuad.alpha -=0.05;
			
			counterLabel.text = "Girls: "+ GS.girlsCounter;
			
			
			if (shake>0 && this.canvasImg.y > -10) 
				{canvasImg.y-= shake;
				 shake =0;
				}
			if (canvasImg.y<0)canvasImg.y++;			
			//рендер			
			if (Man.health >0)	
			{

				if (Man.mode==0) 
				{
					var absDX:Number = Math.abs(man.dx); //абс. значение текущей скорости
					var absDY:Number = Math.abs(man.dy); //абс. значение текущей скорости
					if (keyPressedRight &&  absDX < man.maxSpeed) {man.dx +=man.acceleration;}
					if (keyPressedLeft  &&  absDX < man.maxSpeed) {man.dx -=man.acceleration;}	
					
					if (keyPressedUp 	&&  absDY 	< man.maxSpeed) {man.dy -=man.acceleration;}
					if (keyPressedDown  &&  absDY 	< man.maxSpeed) {man.dy +=man.acceleration;}	
				}
				man.update();	
				energyQuad.width = Man.mojo;

				var vpx:int;
				var vpy:int;
				var delta:int;
				var lag:int;
				if (Man.curState <10) 	vpx = Man.xx - GS.thirdGameWidth; 
				else vpx = Man.xx - 2*GS.thirdGameWidth;
				
				delta = Math.abs(vpx - viewPoint.x); 
				lag = int(delta/10);
				
				if (viewPoint.x < vpx)viewPoint.x+=lag;
				else if(viewPoint.x > vpx)viewPoint.x-=lag;		
				
				viewPoint.y=Man.yy - 3*GS.gameHeight/5;
				

				if (viewPoint.x<0)viewPoint.x =0;	
				if (viewPoint.y<0)viewPoint.y =0;
				if (viewPoint.x>Map.maxXX) viewPoint.x=Map.maxXX; 
				if (viewPoint.y>Map.maxYY) viewPoint.y=Map.maxYY;
				
				viewRect.x= viewPoint.x; 
				viewRect.y= viewPoint.y;				
			}
				
			
			Mob.updateAll();
			Effect.updateAll();
			Bullet.updateAll();

			
			canvas.drawBundled(bundle);	
		
			
		}	
//---------------------------------------------------------------------------------------------
		final private function bundle():void
		{			
			renderMap();
			Mob.drawAll();
			Effect.drawAll();
			Sparks.update();
			Bullet.drawAll();	
		}
		
		final private function renderMap():void
		{
			
			var PTTSize:int = Map.PTTSize; 
			var curLineX:int 	= viewPoint.x >> PTTSize; 
			var curLineY:int 	= viewPoint.y >> PTTSize; 
			
			var deltaX:int 		= viewPoint.x % 32;  
			var deltaY:int 		= viewPoint.y % 32;
			
			//рисуем 	
			var tile:Image;
			for (var y:int=0; y<10; y++) 
			{
				for (var x:int=0; x < 17 ;x++) 
				{
						if (Map.renderMap[y+curLineY][x+curLineX]!= undefined)
						{
							tile = Map.renderMap[y+curLineY][x+curLineX];
							tile.x =  (x<<PTTSize)-deltaX;
							tile.y =  (y<<PTTSize)-deltaY;
							canvas.draw(tile,null,0.999,0);	
						}
				}
			}			
		}	

		
//--------------------------------------------------------------------------------------------		
		private var touch:Touch;
		private var touchX:Number;
		private var touchY:Number;
		
		private var touches:Vector.<Touch>;
		private var touchesCount:int;
		//+++++++++++++++++++++++
		final private function onTouch(e:TouchEvent):void
		{
			try
			{
				touches = e.getTouches(stage,null,touches);
			}   
			catch (error:Error){}
			
			if (touches)
			{	
			
				touchesCount =touches.length; 
				for (var i:int = 0; i < touchesCount; i++) 
				{
					touch = touches[i];
					touchX = touch.globalX;
					touchY = touch.globalY;	
					
					if (touch.phase == TouchPhase.BEGAN)
					{

					}					
					else if (touch.phase == TouchPhase.ENDED)
					{

					}				
				}
				touches.length =0;
			}				
		
		}		
		

		public function hide():void
		{
			if (stage.hasEventListener(starling.events.TouchEvent.TOUCH)) stage.removeEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			if (this.hasEventListener(starling.events.Event.ENTER_FRAME)) this.removeEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);
			
			if (this.hasEventListener(starling.events.KeyboardEvent.KEY_DOWN))  this.removeEventListener(starling.events.KeyboardEvent.KEY_DOWN,KeyDownListener_func);
			if (this.hasEventListener(starling.events.KeyboardEvent.KEY_UP)) 	this.removeEventListener(starling.events.KeyboardEvent.KEY_UP,  KeyUpListener_func);
			
			
			if (themeSC)themeSC.stop();
			this.visible =false;
		}		

		public function show(restart:Boolean =false):void
		{
			if (restart) doRestart();
			
			else 
			{	
				themeSC = Assets.theme_sound.play(0,1000);

			}				
				
			Game.gameState =100;
			stage.addEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			this.addEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);	
			
			this.addEventListener(starling.events.KeyboardEvent.KEY_DOWN,KeyDownListener_func);
			this.addEventListener(starling.events.KeyboardEvent.KEY_UP,  KeyUpListener_func);
			
			this.visible =true;				
		}	

		//*******************************************************************************			
	}
}