package gameClasses
{
	public class Sparks
	{
		protected static var cashe:Vector.<Spark> = new Vector.<Spark>();		
		protected static var activeQuads:Vector.<Spark> = new Vector.<Spark>();		
//--------------------------------------------------------		
		public function Sparks()
		{
			for (var i:int = 0; i < 30; i++) 
			{
				cashe.push(new Spark());
			}			
		}		
		
//--------------------------------------------------------		
public static function update():void
{
	var s:Spark;
	var al:int = activeQuads.length;
	for (var i:int = 0; i < al; i++) 
	{
		s = activeQuads[i];		
		if (s.active) s.update();
		else
		{ 
			cashe.push(s);
			activeQuads.splice(i,1);
			al--;
		}
	}
}

//------------------------------------------------------
public static function add(x:int, y:int, type:int):void
{
	var s:Spark;
	var i:int;
	
	switch(type)
	{
		case 0: //розовый пепел
			for ( i = 0; i < 9; i++) 
			{	s= cashe.pop();
				if(s){
					s.reset(0);
					s.width =s.height =8;
					s.gravity =-0.1;
					s.xx=x;
					s.yy=y;	
					s.color =0xff00ff;
					activeQuads.push(s);}}
			break;
		case 1:
			for ( i = 0; i < 5; i++) 
			{	s= cashe.pop();
				if(s){
					s.reset(0);
					s.width =s.height =9;
					s.gravity =-0.1;
					s.xx=x;
					s.yy=y;	
					s.color =0xFF0000;
					activeQuads.push(s);}}
			break;
		case 2:
			for ( i = 0; i < 3; i++) 
			{	s= cashe.pop();
				if(s){
					s.reset(1);
					s.gravity =0.3;
					s.width =s.height =4;
					s.xx=x;
					s.yy=y;	
					s.color =0xffcc66;
					activeQuads.push(s);}}
			break;
		case 3:
			for ( i = 0; i < 3; i++) 
			{	s= cashe.pop();
				if(s){
					s.reset(1);
					s.gravity =0.3;
					s.width =s.height =4;
					s.xx=x;
					s.yy=y;	
					s.color =0xCCCCCC;
					activeQuads.push(s);}}
			break;
		case 4:
			for ( i = 0; i < 5; i++) 
			{	s= cashe.pop();
				if(s){
					s.reset(0);
					s.gravity =-0.2;
					s.width =s.height =4;
					s.xx=x;
					s.yy=y;	
					s.color =0x00FF00;
					s.alpha=0.5;
					activeQuads.push(s);}}
			break;
		
	}	
	

}
		
//--------------------------------------------------------		
	}
}