package
{
	import flash.ui.Keyboard;
	
	import gameClasses.Girl;
	import gameClasses.Man;
	
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.KeyboardEvent;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.text.TextField;

	
	public class GameOver extends Sprite
	{
		public static var text2:TextField;
		
		public function GameOver()
		{
			super();
			this.scaleX=this.scaleY =GS.scaleIndex;
			var text:TextField = new TextField(160,30, "Game over" , "Verdana",16, 0xFFFF00,true);
			text.x = GS.halfGameWidth -text.width/2;
			text.y = GS.halfGameHeight -text.height/2;
			text.border = true;
			this.addChild(text);
			
			var text1:TextField = new TextField(160,20, "Press [Enter] to restart" , "Verdana",10, 0xcccccc,false);
			text1.x = GS.halfGameWidth -text1.width/2;
			text1.y = text.y + 60;
			this.addChild(text1);		

			text2 =new TextField(300,50,"Girls: ", "Verdana",16, 0xFF00FF,true);
			text2.x = GS.halfGameWidth -text2.width/2;
			text2.y = text.y - 60;
			this.addChild(text2);
			
		}		
		

//-----------------------------------------------------------------------------------------------			
		private function onEnterFrame():void
		{
			
		}	
		
//---------------------------------------------------------------------------------------------
		private function KeyDownListener_func(e:starling.events.KeyboardEvent):void
		{
			if (Game.gameState == 200) 
			{	
				switch (e.keyCode) 
				{
					case Keyboard.ENTER:
						Game.restart = true;
						Game.gameState =100;				
						break;
				}
			}			
		}			
//--------------------------------------------------------------------------------------------		
		private var touch:Touch;
		private var touchX:Number;
		private var touchY:Number;
		private function onTouch(e:TouchEvent):void
		{
			try
			{
				touch = e.getTouch(stage);
				touchX = touch.globalX;
				touchY = touch.globalY;			
			}   catch (error:Error){}
			
			if (touch)
			{
				if (touch.phase == TouchPhase.BEGAN)
				{
					Game.restart = true;
					Game.gameState =100;
				}
			}
		}

		public function hide():void
		{
			if (stage.hasEventListener(starling.events.TouchEvent.TOUCH)) stage.removeEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			if (this.hasEventListener(starling.events.Event.ENTER_FRAME)) this.removeEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);
			if (this.hasEventListener(starling.events.KeyboardEvent.KEY_DOWN))  this.removeEventListener(starling.events.KeyboardEvent.KEY_DOWN,KeyDownListener_func);
			this.visible =false;
		}		

		public function show():void
		{
			Game.gameState =200;
			stage.addEventListener(starling.events.TouchEvent.TOUCH, onTouch);			
			this.addEventListener(starling.events.Event.ENTER_FRAME, onEnterFrame);	
			this.addEventListener(starling.events.KeyboardEvent.KEY_DOWN,KeyDownListener_func);
			
			text2.text = "Girls: "+ GS.girlsCounter.toString();
			Assets.gameoverSnd.play();
			
			this.visible =true;			
		}		
	
	}
}